Copyright (c) 1998 Daan Leijen,  leijen@@fwi.uva.nl

> module LibIO (
>       always, onfail,
>       mapio
>   ) where
>
> import LibMonad (mapm)
>
> mapio :: (a -> b) -> IO a -> IO b
> mapio = mapm
>
> always :: IO a -> IO () -> IO a
> always io action
>       = do x <- io `onfail` action
>            action
>            return x
>
> onfail :: IO a -> IO () -> IO a
> onfail io action
>       = io `catch` \err -> do { action; fail err }
